name: Acceptance Tests

on:
  workflow_dispatch:
  push:

env:
  NODE_OPTIONS: '--max_old_space_size=4096'

jobs:
  docker_container:
    if: "!contains(github.event.commits[0].message, 'skip all') && !contains(github.event.commits[0].message, 'skip acceptance')"
    runs-on: ubuntu-latest
    strategy:
      matrix:
        pg_role_test: [chemotion_test]
        pg_database_test: [chemotion_test]
        pg_password: [123456]
    container:
      image: complat/complat-ubuntu-runner:development-5.ba0e49c5
    env:
      HOME: /home/gitlab-runner

    services:
      postgres:
        image: postgres
        ports:
          - 5433:5432
        env:
          POSTGRES_PASSWORD: postgres
        options: >-
          --health-cmd pg_isready
          --health-interval 10s
          --health-timeout 5s
          --health-retries 5

    steps:
      - name: git clone + postgres
        working-directory: /home/gitlab-runner
        env:
          POSTGRES_HOST: postgres
          POSTGRES_PORT: 5433
        run: |
            sudo git clone --branch $(echo $GITHUB_REF | cut -d'/' -f 3) --depth 1 https://github.com/${GITHUB_REPOSITORY}

            sudo bash ./chemotion_ELN/.github/workflows/config.sh

            echo "POSTGRES"
            psql -d postgresql://postgres:postgres@postgres/postgres -c "CREATE ROLE ${{ matrix.pg_role_test }} LOGIN CREATEDB NOSUPERUSER PASSWORD '${{ matrix.pg_password }}'"
            psql -d postgresql://postgres:postgres@postgres/postgres -c "CREATE DATABASE ${{ matrix.pg_database_test }} OWNER ${{ matrix.pg_role_test }};"
            psql -d postgresql://${{ matrix.pg_role_test }}:${{ matrix.pg_password }}@postgres/${{ matrix.pg_database_test }} -c 'CREATE EXTENSION IF NOT EXISTS "pg_trgm"; CREATE EXTENSION IF NOT EXISTS "hstore"; CREATE EXTENSION IF NOT EXISTS "uuid-ossp";'

            sudo chmod -R +x chemotion_ELN/spec
            sudo chown -R gitlab-runner:gitlab-runner chemotion_ELN

      - name: bundle + yarn install
        working-directory: /home/gitlab-runner/chemotion_ELN
        run: |
            /bin/bash -l -c "source /home/gitlab-runner/.asdf/asdf.sh && bundle install"
            /bin/bash -l -c "source /home/gitlab-runner/.asdf/asdf.sh && yarn install"

      - name: precompile
        working-directory: /home/gitlab-runner/chemotion_ELN
        run: |
            /bin/bash -l -c "source /home/gitlab-runner/.asdf/asdf.sh && RAILS_ENV=test bundle exec rake db:migrate db:test:prepare > /dev/null"

            mv public/welcome-message-sample.md public/welcome-message.md

            /bin/bash -l -c "source /home/gitlab-runner/.asdf/asdf.sh && RAILS_ENV=test bundle exec rails webpacker:compile"
            sleep 30

      - name: testacceptance
        working-directory: /home/gitlab-runner/chemotion_ELN
        run: |
            /bin/bash -l -c "source /home/gitlab-runner/.asdf/asdf.sh && RAILS_ENV=test bundle exec rspec spec/features"
